// MysubmailRealname.go
package main

import (
	"crypto/md5"
	"crypto/tls"
	"encoding/hex"
	"fmt"
	"log"
	"os"
	"regexp"

	"strings"
	"time"

	"io/ioutil"

	"net/http"

	"github.com/Unknwon/goconfig"
	"github.com/pingo"
)

var (
	scheme         = "" // 1=https://   0=http://
	encryption_key = "" //取本地app.conf文件中的enkey
)

type JuheRealname struct{}

func main() {
	plugin := &JuheRealname{}
	pingo.Register(plugin)
	pingo.Run()

}

func (p *JuheRealname) Action(mapPublic map[string]string, msg *string) error {

	result := "-1|The variable is empty"

	rstack_domain := mapPublic["rstack_domain"]
	rstack_ssl := mapPublic["rstack_ssl"]

	scheme = "http://"
	if rstack_ssl == "1" {
		scheme = "https://"
	}

	//财务设定的短信签名，如果有的短信接口需要传输自己的签名则用这个传输即可，不过大部分都没有的。
	//sms_signature := mapPublic["sms_signature"]

	rnid := IF(!IsNum(mapPublic["rnid"]), "0", mapPublic["rnid"])
	//短信类型。
	action := mapPublic["action"]

	if action == "checkrealname" {

		resellerMode := IF(!IsNum(mapPublic["resellerMode"]), "0", mapPublic["resellerMode"])
		resellerID := IF(!IsNum(mapPublic["resellerID"]), "0", mapPublic["resellerID"])

		curl1 := scheme + rstack_domain + mapPublic["rstack_requesturi"]

		//获取模块自定义参数
		text := GetSMSParameter(encryption_key, rnid, curl1, resellerMode, resellerID, rstack_domain)

		if strings.HasPrefix(text, "-1|") == true {
			result = text
		} else {

			apiURL := GetValue(text, "apiURL")

			appKEY := GetValue(text, "appKEY")
			mapPost := make(map[string]string)
			mapPost["key"] = appKEY
			mapPost["realname"] = mapPublic["name"]
			mapPost["idcard"] = mapPublic["idcard"]
			mapPost["mobile"] = mapPublic["phone"]
			mapPost["type"] = "1"
			mapPost["showid"] = "1"
			mapPost["province"] = "1"
			mapPost["detail"] = "1"

			cstr, err := ModulePostData(apiURL, mapPost, 15)

			if err != nil {
				result = "-1|" + fmt.Sprint(err)
			} else {
				//fmt.Println("返回：", cstr)
				error_code := GetValue(cstr, "error_code")
				if error_code == "0" {
					getResult := GetValue(cstr, "result")
					if GetValue(getResult, "res") == "1" {
						result = "0|0"
					} else {
						result = "-1|" + GetValue(getResult, "resmsg")
						if result == "-1|" {
							result = "-1|接口返回为空,可能数据错误！"
						}
					}
				} else {
					//
					switch error_code {
					case "10001":
						result = "-1|错误的请求KEY"
					case "10002":
						result = "-1|该KEY无请求权限"
					case "10003":
						result = "-1|KEY过期"
					case "10004":
						result = "-1|错误的OPENID"
					case "10005":
						result = "-1|应用未审核超时，请提交认证"
					case "10007":
						result = "-1|未知请求源"
					case "10008":
						result = "-1|被禁止的IP"
					case "10009":
						result = "-1|被禁止的KEY"
					case "10011":
						result = "-1|当前IP请求超过限制"
					case "10012":
						result = "-1|请求超过次数限制"
					case "10013":
						result = "-1|测试KEY超过请求限制"
					case "10014":
						result = "-1|系统内部异常(调用充值类业务时，请务必联系客服或通过订单查询接口检测订单，避免造成损失)"
					case "10020":
						result = "-1|接口维护"
					case "10021":
						result = "-1|接口停用"
					case "220801":
						result = "-1|数据源超时"
					case "220802":
						result = "-1|数据源异常"
					case "220803":
						result = "-1|查询无此记录"
					case "220807":
						result = "-1|参数错误，具体请看reason"
					default:
						result = "-1|error:" + error_code
					}
				}

			}

		}

	} else if action == "admin_realname_config" || action == "reseller_realname_config" {
		subaction := mapPublic["subaction"]
		sign := mapPublic["sign"]

		enSign1 := Md5_default(action + subaction + encryption_key + rnid)

		if enSign1 == sign {
			text2 := Module_OpenFile("JuheRealname", action)
			if strings.HasPrefix(text2, "-1") == false {
				result = text2
			} else {
				result = "-1|Script file not found!"
			}

		} else {
			result = "-1|Invalid sign|0"
		}
	}

	*msg = result

	return nil
}

func GetSMSParameter(encryption_key string, rnid string, currentUrl string, resellerMode string, resellerID string, rHost string) string {

	//去尾
	if currentUrl != "" {
		currentUrl = currentUrl[0 : strings.LastIndex(currentUrl, "/")+1]
	}

	map1 := make(map[string]string)
	map1["apiDomain"] = ""
	map1["action"] = "get_parameter" //获取模块config字段的JSON自定义参数。
	map1["type"] = "realname"
	map1["resellerMode"] = resellerMode
	map1["resellerID"] = resellerID
	map1["rnid"] = rnid
	map1["sign"] = Md5_default(rnid + encryption_key + currentUrl)

	cstr, err := ModulePostData(scheme+rHost+"/process?c=modules", map1, 10)
	if err != nil {
		return "-1|get_parameter Error:" + fmt.Sprint(err)
	}

	return cstr

}

//模块提交POST交互
func ModulePostData(urladdr string, map1 map[string]string, timeout int) (ret string, err error) {
	var client *http.Client
	if strings.HasPrefix(urladdr, "https://") == true {
		tr := &http.Transport{
			TLSClientConfig: &tls.Config{InsecureSkipVerify: true},
		}

		client = &http.Client{Transport: tr}
	} else {
		client = &http.Client{}
	}

	fields := ""
	for k, v := range map1 {
		if fields == "" {
			fields = k + "=" + v
		} else {
			fields += "&" + k + "=" + v
		}
	}

	req, err := http.NewRequest("POST", urladdr, strings.NewReader(fields))
	if err != nil {
		return "", err
	}

	req.Header.Add("Content-Type", "application/x-www-form-urlencoded")
	req.Header.Add("Accept", "*/*")
	req.Header.Add("User-Agent", "RStack Platform/1.0")

	resp, err := client.Do(req)
	if err != nil {
		return "", err
	}

	defer resp.Body.Close()

	body, err := ioutil.ReadAll(resp.Body)

	if err != nil {
		return "", err
	}

	return string(body), nil
}

//打开文件错误返回 -1|错误信息
func Module_OpenFile(moduleName string, str string) string {
	result := ""
	var err error
	if str != "" {
		result, err = OpenFile("static/modules/realname/" + moduleName + "/js/" + str + ".js")
		if err != nil {
			result = "-1|Script file not found"
			return result
		}
	}

	return result

}

func OpenFile(path string) (str string, err error) {
	f, err := os.Open(path)
	if err != nil {
		return "", err
	}

	str0, err := ioutil.ReadAll(f)

	if err != nil {
		return "", err
	}

	str = string(str0)

	return str, nil
}

func GetValue(json, string_0 string) string {
	text := ""

	string_0 = "\"" + string_0 + "\":"

	if strings.Index(json, string_0) > -1 {

		text = json[strings.Index(json, string_0)+len(string_0):]

		num := 0
		num2 := 0

		if strings.HasPrefix(text, "\"") == true {

			if strings.Index(text, "\",\"") > -1 {

				num2 = strings.Index(text, "\",\"")

			} else {
				num2 = strings.LastIndex(text, "\"")
			}
			num = 1

		} else if strings.HasPrefix(text, "{") == true {

			if strings.Index(text, "\"},\"") > 0 {

				//找到 "},"
				num2 = strings.Index(text, "\"},\"") + 2 //   "},"
			} else if strings.Index(text, "\"}") > 0 { // "}

				num2 = strings.Index(text, "\"}") + 2
			} else if strings.Index(text, "}") > 0 { // }

				num2 = strings.Index(text, "}") + 1
			}

		} else if strings.Index(text, ",") > -1 {
			num2 = strings.Index(text, ",")
		} else {

			num2 = strings.Index(text, "}")
		}

		if num > num2 {
			//防止索引错误导致程序异常。
			text = ""
		} else {
			text = text[num:num2]
		}

		if strings.HasPrefix(text, "{") == false && strings.Index(text, "\"") > -1 {
			text = text[0:strings.Index(text, "\"")]

		}
	}

	return text
}

func IsNum(isnumber string) bool {

	b2, err := regexp.MatchString("^[+-]?\\d*[.]?\\d*$", isnumber)
	if err != nil {
		return false
	}
	return b2 && isnumber != ""
}

func IF(ifstr bool, true1, false2 string) string {
	if ifstr {
		return true1
	}
	return false2
}

//MD5加密
func Md5_default(md5_default string) string {
	h := md5.New()
	h.Write([]byte(md5_default))
	return hex.EncodeToString(h.Sum(nil))

}

func init() {
	pwd, err := os.Getwd()
	if err != nil {

		log.Println("Get Pwd Error：", err)
		return
	} else {
		pwd = strings.Replace(pwd, "\\", "/", -1)
		pwd = strings.Replace(pwd, "/bin", "", -1)

		cfg, err := goconfig.LoadConfigFile(pwd + "/conf/app.conf")
		if err != nil {
			log.Println("Load app.conf Error:", err)
		} else {

			enKey, err := cfg.GetValue("listen", "enKey")
			if err != nil {
				log.Println("Get listen domain", err)
				return
			}
			encryption_key = enKey

			//如果未设置，随机生成一个字符串enKey，让API失效。
			if encryption_key == "" {
				encryption_key = time.Now().Format("20060102150405")
			}
		}
	}
}
